Subject: bug#66113: Apply the entire diff buffer

From: Juri Linkov <[email-masked]>
Date: Fri, 22 Sep 2023 18:48:49 +0300

>>>> +          (t
>>>> +           (dolist (buf buffers)
>>>> +             (with-current-buffer buf
>>>> +               (display-buffer buf)))
>>>> +           (message "%d hunks failed; no buffers saved" failures)))))
>>>
>>> What happens next in this case? How do you undo in the buffers that had the
>>> patch hunks already applied?
>> Manually, like in case of ediff-patch-buffer.
>
> I've never used this, so I don't understand.

ediff-patch-buffer is an example when trying to roll back a mess
creates more mess with .orig/.rej files.

>>> Any change you wanted to work on the idea of the "atomic rollback" as well?
>> This would be an unreliable feature: in case of diff-apply creates
>> a mess,
>> such automatic undo can create more mess, because there are many different
>> strategies to undo the mess such as using undo-auto-amalgamate, or
>> applying the reverse diff partially, doing more damage in case when
>> buffers were already modified before diff-apply.
>
> How about we save the tips of buffer-undo-list, then in case the buffer
> needs reverting, basically 'undo' each of the buffers until the saved "tip"
> is reached? I don't have a quick code anippet, but that seems doable.

Maybe, but I definitely won't use such an option.

>> But fortunately the need to undo will be extremely rare, because
>> when patch hunks are already applied, it reports the failure,
>> but doesn't modify the source buffer.  Therefore there is
>> nothing to undo!
>
> The problem situations is, of course, when one of the hunks (somewhere in
> the middle or near the end) fails to apply cleanly or at all.

Indeed, this is a problematic case when one of the hunks fails
whereas all other hunks are applied cleanly.  This sometimes happens
when receiving an external patch, but the source already changed.

> Another approach would be to first go through the patch and check that all
> hunks apply without problems, and then, on the second pass, actually apply
> them.

This is a better option, thanks for the idea, will try to do this with
'diff-test-hunk' in a loop.